8821cu-20210916/install-driver.sh

307 lines
8.3 KiB
Bash
Raw Normal View History

2022-11-17 14:26:57 +00:00
#!/bin/bash
# Purpose: Install Realtek out-of-kernel USB WiFi adapter drivers.
#
# Supports dkms and non-dkms installations.
2022-12-08 14:10:21 +00:00
# Copyright(c) 2022 Nick Morrow
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
2022-11-17 14:26:57 +00:00
SCRIPT_NAME="install-driver.sh"
2022-12-29 04:22:19 +00:00
SCRIPT_VERSION="20221228"
2022-11-17 14:26:57 +00:00
MODULE_NAME="8821cu"
DRV_VERSION="5.12.0.4"
KVER="$(uname -r)"
KARCH="$(uname -m)"
KSRC="/lib/modules/${KVER}/build"
MODDESTDIR="/lib/modules/${KVER}/kernel/drivers/net/wireless/"
DRV_NAME="rtl${MODULE_NAME}"
DRV_DIR="$(pwd)"
2022-12-08 14:10:21 +00:00
OPTIONS_FILE="${MODULE_NAME}.conf"
2022-11-17 14:26:57 +00:00
# check to ensure sudo was used
if [[ $EUID -ne 0 ]]
then
echo "You must run this script with superuser (root) privileges."
echo "Try: \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2022-12-15 14:30:39 +00:00
# ensure /usr/sbin is in the PATH so iw can be found
if ! echo "$PATH" | grep -qw sbin; then
export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
fi
2022-12-08 02:11:44 +00:00
# check to ensure gcc is installed
if ! command -v gcc >/dev/null 2>&1
then
echo "A required package is not installed."
2022-12-08 02:11:44 +00:00
echo "Please install the following package: gcc"
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
# check to ensure make is installed
if ! command -v make >/dev/null 2>&1
2022-12-06 15:32:40 +00:00
then
echo "A required package is not installed."
echo "Please install the following package: make"
2022-12-06 15:32:40 +00:00
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2022-12-12 07:49:04 +00:00
# check to see if header files are installed
if [ ! -d "/lib/modules/$(uname -r)/build" ]; then
echo "Your kernel header files aren't properly installed."
2022-12-12 07:49:04 +00:00
echo "Please consult your distro documentation."
echo "Once the header files are installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
# check to ensure iw is installed
if ! command -v iw >/dev/null 2>&1
2022-11-29 22:20:51 +00:00
then
echo "A required package is not installed."
echo "Please install the following package: iw"
2022-11-29 22:20:51 +00:00
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
# check to ensure rfkill is installed
if ! command -v rfkill >/dev/null 2>&1
then
echo "A required package is not installed."
2022-11-29 22:20:51 +00:00
echo "Please install the following package: rfkill"
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2022-12-08 02:11:44 +00:00
# check to ensure nano is installed
if ! command -v nano >/dev/null 2>&1
then
echo "A required package is not installed."
2022-12-08 02:11:44 +00:00
echo "Please install the following package: nano"
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2022-11-17 14:26:57 +00:00
# support for the NoPrompt option allows non-interactive use of this script
NO_PROMPT=0
# get the script options
while [ $# -gt 0 ]
do
case $1 in
NoPrompt)
NO_PROMPT=1 ;;
*h|*help|*)
echo "Syntax $0 <NoPrompt>"
echo " NoPrompt - noninteractive mode"
echo " -h|--help - Show help"
exit 1
;;
esac
shift
done
# displays script name and version
echo "Script: ${SCRIPT_NAME} version ${SCRIPT_VERSION}"
2022-11-17 14:26:57 +00:00
# check for and remove non-dkms installation
if [[ -f "${MODDESTDIR}${MODULE_NAME}.ko" ]]
then
echo "Removing a non-dkms installation."
rm -f ${MODDESTDIR}${MODULE_NAME}.ko
/sbin/depmod -a ${KVER}
fi
# check for existing dkms installations of any version of this driver
2022-12-17 22:55:37 +00:00
if command -v dkms >/dev/null 2>&1
then
if dkms status | grep -i ${DRV_NAME}; then
echo "The above driver needs to be removed before the installation can be successfull."
echo "Example: $ sudo dkms remove ${DRV_NAME}/X.X.X.X --all"
echo "Please replace X.X.X.X by the driver version number shown above."
echo "Once the driver is removed, please run \"sudo ./${SCRIPT_NAME}\""
2022-12-17 22:55:37 +00:00
exit 1
fi
fi
2022-11-17 14:26:57 +00:00
# information that helps with bug reports
2022-12-05 03:53:57 +00:00
2022-12-07 18:02:14 +00:00
# display kernel version
echo "Kernel: ${KVER}"
2022-12-05 03:53:57 +00:00
2022-12-07 18:02:14 +00:00
# display architecture
echo "Arch: ${KARCH}"
2022-12-05 03:53:57 +00:00
2022-12-06 15:32:40 +00:00
# display gcc version
2022-12-05 03:53:57 +00:00
gcc_ver=$(gcc --version | grep -i gcc)
echo "gcc: "${gcc_ver}
2022-12-05 03:53:57 +00:00
2022-12-09 18:31:49 +00:00
# display ISO 3166-1 alpha-2 Country Code
2022-12-05 19:47:32 +00:00
a2_country_code=$(iw reg get | grep -i country)
echo "Country: "${a2_country_code}
2022-12-14 00:28:08 +00:00
if [[ $a2_country_code == *"00"* ]];
then
echo "The Country Code may not be properly set."
echo "File alpha-2_Country_Codes is located in the driver directory."
echo "Please read and follow the directions in the file after installation."
2022-12-14 00:28:08 +00:00
fi
2022-12-05 19:47:32 +00:00
2022-12-09 04:34:43 +00:00
# display secure mode status
2022-12-08 01:39:10 +00:00
# run if mokutil is installed
if command -v mokutil >/dev/null 2>&1
then
mokutil --sb-state
fi
2022-11-17 14:26:57 +00:00
2022-12-12 05:28:17 +00:00
# sets module parameters (driver options) and blacklisted modules
2022-12-27 03:57:44 +00:00
echo "Installing ${OPTIONS_FILE} to /etc/modprobe.d"
2022-11-17 14:26:57 +00:00
cp -f ${OPTIONS_FILE} /etc/modprobe.d
# determine if dkms is installed and run the appropriate routines
if ! command -v dkms >/dev/null 2>&1
then
echo "The non-dkms installation routines are in use."
2022-11-18 16:36:46 +00:00
make clean >/dev/null 2>&1
2022-11-17 14:26:57 +00:00
2022-12-29 04:22:19 +00:00
make -j$(nproc)
2022-11-17 14:26:57 +00:00
RESULT=$?
if [[ "$RESULT" != "0" ]]
then
echo "An error occurred: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "You will need to run the following before reattempting installation."
2022-11-18 16:36:46 +00:00
echo "$ sudo ./remove-driver.sh"
2022-11-17 14:26:57 +00:00
exit $RESULT
fi
# As shown in Makefile
# install:
# install -p -m 644 $(MODULE_NAME).ko $(MODDESTDIR)
# /sbin/depmod -a ${KVER}
make install
RESULT=$?
if [[ "$RESULT" = "0" ]]
then
2022-12-15 16:48:43 +00:00
make clean >/dev/null 2>&1
2022-11-17 14:26:57 +00:00
echo "The driver was installed successfully."
else
echo "An error occurred: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "You will need to run the following before reattempting installation."
2022-11-18 16:36:46 +00:00
echo "$ sudo ./remove-driver.sh"
2022-11-17 14:26:57 +00:00
exit $RESULT
fi
else
echo "The dkms installation routines are in use."
# the dkms add command requires source in /usr/src/${DRV_NAME}-${DRV_VERSION}
echo "Copying source files to /usr/src/${DRV_NAME}-${DRV_VERSION}"
2022-11-17 14:26:57 +00:00
cp -rf "${DRV_DIR}" /usr/src/${DRV_NAME}-${DRV_VERSION}
2022-12-27 03:57:44 +00:00
2022-11-17 14:26:57 +00:00
dkms add -m ${DRV_NAME} -v ${DRV_VERSION}
RESULT=$?
# RESULT will be 3 if the DKMS tree already contains the same module/version
# combo. You cannot add the same module/version combo more than once.
if [[ "$RESULT" != "0" ]]
then
if [[ "$RESULT" = "3" ]]
then
2022-12-14 00:28:08 +00:00
echo "This driver may already be installed."
2022-11-17 14:26:57 +00:00
echo "Run the following and then reattempt installation."
echo "$ sudo ./remove-driver.sh"
2022-12-27 03:57:44 +00:00
exit $RESULT
2022-11-17 14:26:57 +00:00
else
echo "An error occurred. dkms add error: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "Run the following before reattempting installation."
echo "$ sudo ./remove-driver.sh"
exit $RESULT
fi
else
2022-12-07 18:02:14 +00:00
echo "The driver was added to dkms successfully."
2022-11-17 14:26:57 +00:00
fi
if command -v /usr/bin/time >/dev/null 2>&1
then
/usr/bin/time -f "Compile time: %U seconds" dkms build -m ${DRV_NAME} -v ${DRV_VERSION}
else
dkms build -m ${DRV_NAME} -v ${DRV_VERSION}
fi
2022-11-17 14:26:57 +00:00
RESULT=$?
if [[ "$RESULT" != "0" ]]
then
echo "An error occurred. dkms build error: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "Run the following before reattempting installation."
echo "$ sudo ./remove-driver.sh"
exit $RESULT
else
2022-12-07 18:02:14 +00:00
echo "The driver was built by dkms successfully."
2022-11-17 14:26:57 +00:00
fi
dkms install -m ${DRV_NAME} -v ${DRV_VERSION}
RESULT=$?
if [[ "$RESULT" != "0" ]]
then
echo "An error occurred. dkms install error: ${RESULT}"
2022-11-17 14:26:57 +00:00
echo "Please report this error."
echo "Please copy all screen output and paste it into the problem report."
2022-11-17 14:26:57 +00:00
echo "Run the following before reattempting installation."
echo "$ sudo ./remove-driver.sh"
exit $RESULT
else
2022-12-07 18:02:14 +00:00
echo "The driver was installed by dkms successfully."
2022-11-17 14:26:57 +00:00
fi
fi
# unblock wifi
2022-11-20 04:57:12 +00:00
if command -v rfkill >/dev/null 2>&1
then
rfkill unblock wlan
else
2022-12-27 03:57:44 +00:00
echo "Unable to run $ rfkill unblock wlan"
2022-11-20 04:57:12 +00:00
fi
2022-11-17 14:26:57 +00:00
# if NoPrompt is not used, ask user some questions
2022-11-17 14:26:57 +00:00
if [ $NO_PROMPT -ne 1 ]
then
read -p "Do you want to edit the driver options file now? [y/N] " -n 1 -r
2022-12-06 15:32:40 +00:00
echo
2022-11-17 14:26:57 +00:00
if [[ $REPLY =~ ^[Yy]$ ]]
then
nano /etc/modprobe.d/${OPTIONS_FILE}
fi
read -p "Do you want to reboot now? (recommended) [y/N] " -n 1 -r
2022-12-06 15:32:40 +00:00
echo
2022-11-17 14:26:57 +00:00
if [[ $REPLY =~ ^[Yy]$ ]]
then
reboot
fi
fi
exit 0